package org.ajax4jsf.bean;

import javax.faces.context.FacesContext;

import org.richfaces.component.Dropzone;
import org.richfaces.event.DragEvent;
import org.richfaces.event.DragListener;
import org.richfaces.event.DropEvent;
import org.richfaces.event.DropListener;

public class DnDListener implements DragListener, DropListener {

    private DnDBean instance;

    protected DnDBean getDnDBean() {
        if (null == instance) {
            FacesContext fc = FacesContext.getCurrentInstance();
            instance = (DnDBean) fc.getApplication().evaluateExpressionGet(fc, "#{dndBean}", DnDBean.class);
        }

        return instance;
    }

//
// DropListener implementation
//
    public void processDrag(DragEvent event) {
    	DnDBean bean = getDnDBean();
    	bean.setStatus(bean.getStatus() + DnDBean.RICHDRAGLISTENER);
    }

//
// DropListener implementation
//
    public void processDrop(DropEvent event) {
        Dropzone dropzone = (Dropzone) event.getComponent();
        DnDBean bean = getDnDBean();
        bean.moveFramework(event.getDragValue(), dropzone.getDropValue());
        bean.setStatus(bean.getStatus() + DnDBean.RICHDROPLISTENER);
    }

}
